#include <stdio.h> // for putchar

#include "hexfile.hh"
#include "memory.hh"
#include "cpu.hh"

int main()
{
    LoadHexFile("test.hex");

    // Running loop.
    for(;; ++CycleCounter)
    {
        // Execute instruction
        ExecuteOpcode();

        // Update timer 0
        if(++TMR0_prescaler >= (OPTION.PSA ? 1 : (2 << OPTION.PreScale)))
        {
            TMR0_prescaler = 0;
            // Signal the timer 0 interrupt, by simply updating the T0IF flag,
            // when the timer 0 period wraps.
            if(!(unsigned char)++TMR0)
                INTCON.T0IF = true;
        }

        // Update timer 2
        if(++TMR2_prescaler >= (1 << T2CON.PreScale))
        {
            TMR2_prescaler = 0;

            if(++TMR2 > PR2)
            {
                TMR2   = 0;
                CCPR1H = CCPR1L*4 + CCP1CON.lsb;
            }
        }

        // Do pulse modulation (output the waveform to stdout,
        // which simulates our loudspeaker).
        for(unsigned c=0; c<4; ++c)
        {
            bool CCP1 = (TMR2*4+c) < CCPR1H;
            putchar(CCP1 ? 0x40 : 0xC0);
        }
    }
}



